diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/os_comms.p v15.6301-amd64/pop/src/syscomp/os_comms.p
--- v15.63/pop/src/syscomp/os_comms.p	2007-09-10 15:50:14.000000000 -0400
+++ v15.6301-amd64/pop/src/syscomp/os_comms.p	2009-12-24 15:48:52.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2007. All rights reserved. ----------
+/* --- Copyright University of Sussex 1999. All rights reserved. ----------
  > File:			C.unix/src/syscomp/os_comms.p
  > Purpose:
  > Author:			John Gibson (see revisions)
@@ -120,23 +120,12 @@
 	if exlink then
 				out_obj_files(wobj_files)
 	else
-
-		;;; Altered by A.S. to produce a 'sh' file. 4 Jan 2005
-		;;; Altered by A.S. to produce a 'bash' file. 10 Sep 2007
-		;;; asmf_pr('#!/bin/csh -f\n');
-		;;; asmf_pr('#!/bin/sh\n');
-		asmf_pr('#!/bin/bash\n');
-
-		;;; asmf_printf(image_name, 'set IM=$1; if $IM == "" set IM=%p\n');
-		asmf_printf(image_name, 'IM=$1\n if [ ! ${IM} ]; then IM=%p ; fi\n');
+		asmf_pr('#!/bin/sh\n');
+		asmf_printf(image_name, 'IM=$1\nIM=${IM:-%p}\n');
 
 #_IF DEF cc_link_command_header
 		;;; Using C compiler to link (uses $POP__cc as command)
-		;;; asmf_pr('if ! $?POP__cc set POP__cc=cc\n');
-		asmf_pr('if [ ! ${POP__cc} ]; then POP__cc=cc; fi\n');
-
-		;;; shell-neutral bits follow.
-
+		asmf_pr('POP__cc=${POP__cc:-cc}\n');
 		asmf_pr(cc_link_command_header);
 		for f in link_flags do asmf_printf(f, '-Wl,%p \\\n') endfor;
 				out_obj_files(wobj_files);
@@ -167,13 +156,6 @@
 	;;; any X libraries)
 	nl_printf('-lpop');
 
-	;;; A.S.  1 Nov 2003
-	;;; If motif included make it come before other X stuff, so that
-	;;; correct version can be linked to popxternlib/libXm.so
-	if member('-lXm', link_other) then
-		nl_printf('-lXm');
-		delete('-lXm', link_other) -> link_other;
-	endif;
 	out_obj_files(link_other);
 
 	;;; standard libraries
@@ -197,13 +179,11 @@
 		endif);
 
 	unless exlink then
-		;;; asmf_pr('set ST = $status\n');
-		asmf_pr('ST=$status\n');
+		asmf_pr('ST=$?\n');
 
 		if cleanup_command then asmf_printf(cleanup_command, '%p\n') endif;
 		if makebase then
-			;;; asmf_pr('if ($ST == 0) rm -f $IM.stb\n')
-			asmf_pr('if [[ $ST == 0 ]]; then rm -f $IM.stb ; fi\n')
+			asmf_pr('if [ $ST == 0 ] ; then rm -f $IM.stb ; fi\n')
 		endif;
 		asmf_pr('exit $ST\n')
 	endunless;
@@ -329,110 +309,97 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, Sep 10 2007
-		Altered to create a bash script header instead of sh for $popsys/poplink_cmnd
---- Aaron Sloman, Jan  4 2005
-        Changed gen_link_command to produce a version of $popsys/poplink_cmnd
-        that uses 'sh' syntax rather than 'csh', because not all linux systems
-        now come with csh or tcsh installed, which prevents re-linking.
---- Aaron Sloman, Dec 31 2004
-        Altered gen_link_command so that if motif is included it uses a link to
-        the appropriate file is made in
-            $popexternlib/libXm.so
-        e.g. in case there is not a libXm.so link in /usr/X11R6/lib
-        This requires the installation scripts to insert the link in
-        $popexternlib
 --- John Gibson, Apr  9 1999
-        Made out_obj_files convert -R<dirname> to appropriate -rpath args
-        for Linux
+		Made out_obj_files convert -R<dirname> to appropriate -rpath args
+		for Linux
 --- Julian Clinton, Aug  7 1998
-        Add '-lmw' for NCR.
+		Add '-lmw' for NCR.
 --- Robert Duncan, Jul  2 1998
-        Allowed for extra libraries in HP-UX link command
+		Allowed for extra libraries in HP-UX link command
 --- Robert Duncan, Jun 05 1998
-        Added libgen to link command for DG/UX (used at least by libXm)
+		Added libgen to link command for DG/UX (used at least by libXm)
 --- Robert Duncan, Aug 13 1996
-        Added libgen to link command for NCR (used at least by libXm)
+		Added libgen to link command for NCR (used at least by libXm)
 --- John Gibson, Dec  7 1995
-        Now allows env vars POP__as, POP__ar and POP__crt0 (if set) to
-        override AS_CMD, AR_CMD and unix_ld_crt_objects
+		Now allows env vars POP__as, POP__ar and POP__crt0 (if set) to
+		override AS_CMD, AR_CMD and unix_ld_crt_objects
 --- John Gibson, Mar 10 1995
-        OSF changes
+		OSF changes
 --- Poplog System, Jan 18 1995 (Julian Clinton)
-        Set options for Linux and SCO Open Desktop 3.0.
+		Set options for Linux and SCO Open Desktop 3.0.
 --- Robert John Duncan, Mar 21 1994
-        Changes for SG IRIX 5+
+		Changes for SG IRIX 5+
 --- John Gibson, Nov 19 1993
-        Changed gen_link_command to take ______exlink arg to say just produce
-        file containing object/library args
+		Changed gen_link_command to take ______exlink arg to say just produce
+		file containing object/library args
 --- John Gibson, Nov 13 1993
-        -lpop now the only pop library in link command
+		-lpop now the only pop library in link command
 --- John Gibson, Aug 30 1993
-        Replaced run*_poplink with run_comp_util
+		Replaced run*_poplink with run_comp_util
 --- John Gibson, Jul 10 1993
-        Added ________makebase argument to gen_link_command and assemble_and_link
+		Added ________makebase argument to gen_link_command and assemble_and_link
 --- Robert John Duncan, Jun 11 1993
-        Changed gen_link_command to write out explicit references to the pop
-        external libraries using the '-L' and '-l' options to ld and made it
-        take an additional argument -- _____________extern_libdir -- which is the
-        directory containing the libraries as determined by poplink. This is
-        necessary when the libraries are shared, because they may not be in
-        the same directory when the image is run.
-        Also tidied up references to the crt*.o files -- their location can
-        now be specified by defining unix_ld_crt_objects in "asmout.p".
+		Changed gen_link_command to write out explicit references to the pop
+		external libraries using the '-L' and '-l' options to ld and made it
+		take an additional argument -- _____________extern_libdir -- which is the
+		directory containing the libraries as determined by poplink. This is
+		necessary when the libraries are shared, because they may not be in
+		the same directory when the image is run.
+		Also tidied up references to the crt*.o files -- their location can
+		now be specified by defining unix_ld_crt_objects in "asmout.p".
 --- Simon Nichols, Jun  2 1993
-        Removed addition of -ldl/-ldld to link command -- now done with
-        a dummy exload in src/unixextern.p.
+		Removed addition of -ldl/-ldld to link command -- now done with
+		a dummy exload in src/unixextern.p.
 --- Robert John Duncan, Jun  2 1993
-        Changes for SVR4
+		Changes for SVR4
 --- John Gibson, May 23 1993
-        Removed addition of -lt*ermcap to link command -- now done with
-        a dummy exload in src/termcap.p.
+		Removed addition of -lt*ermcap to link command -- now done with
+		a dummy exload in src/termcap.p.
 --- John Gibson, May 14 1993
-        Added _______________cleanup_command arg to gen_link_command
+		Added _______________cleanup_command arg to gen_link_command
 --- John Gibson, May  6 1993
-        Removed addition of c_c*ore.obj from gen_link_command -- this is
-        now part of $popexternlib/libpop.olb.
+		Removed addition of c_c*ore.obj from gen_link_command -- this is
+		now part of $popexternlib/libpop.olb.
 --- Simon Nichols, Mar  2 1993
-        Changed location of crt?.o in Solaris 2.1
+		Changed location of crt?.o in Solaris 2.1
 --- Simon Nichols, Jan 29 1993
-        Changed name of conditional compilation flag SU*NOS_DYNAMIC to
-        SHARED_LIBRARIES, as it's more descriptive and not SunOS specific.
-        Added support for shared libraries on HP-UX.
+		Changed name of conditional compilation flag SU*NOS_DYNAMIC to
+		SHARED_LIBRARIES, as it's more descriptive and not SunOS specific.
+		Added support for shared libraries on HP-UX.
 --- John Gibson, Oct 20 1992
-        Changed os_library_command to hash-encode module names longer
-        than 14 chars
+		Changed os_library_command to hash-encode module names longer
+		than 14 chars
 --- Robert John Duncan, Jul 24 1992
-        Changed location of commands for SunOS 5.0 and the list of
-        libraries to be given to ld
+		Changed location of commands for SunOS 5.0 and the list of
+		libraries to be given to ld
 --- Robert John Duncan, Jul 21 1992
-        Added SYSTEM_V to list of systems which don't need ranlib
+		Added SYSTEM_V to list of systems which don't need ranlib
 --- Simon Nichols, Mar  3 1992
-        Changes to support SunOS dynamic linking (temporarily flagged by
-        SU*NOS_DYNAMIC).
+		Changes to support SunOS dynamic linking (temporarily flagged by
+		SU*NOS_DYNAMIC).
 --- Robert John Duncan, Jun 24 1991
-        Added code for SG IRIX
+		Added code for SG IRIX
 --- John Gibson, Jan 21 1991
-        Added -share- arg to -gen_link_command-
+		Added -share- arg to -gen_link_command-
 --- John Gibson, Nov 22 1990
-        Changed malloc.o to c_c*ore.obj
+		Changed malloc.o to c_c*ore.obj
 --- John Gibson, Nov 22 1990
 --- John Gibson, Sep 27 1990
-        Replaced calls of -interrupt- with mishaps
+		Replaced calls of -interrupt- with mishaps
 --- Rob Duncan, May 31 1990
-        Added non-standard run-time library for DECSTATION
+		Added non-standard run-time library for DECSTATION
 --- John Gibson, May 10 1990
-        Made $popsrc/malloc.o be systranslated (so it gets current
-        value of $popsrc).
+		Made $popsrc/malloc.o be systranslated (so it gets current
+		value of $popsrc).
 --- Rob Duncan, May  8 1990
-        Added patch for MIPS and funny runtime libraries for MIPS/RISCOS
+		Added patch for MIPS and funny runtime libraries for MIPS/RISCOS
 --- Rob Duncan, Nov  7 1989
-        Added t*ermcap library ('-lt*ermcap') to end of link command
+		Added t*ermcap library ('-lt*ermcap') to end of link command
 --- John Gibson, Aug  4 1989
-        Version 13.66+
+		Version 13.66+
 --- John Gibson, Jul 24 1989
-        -os_library_command- moved here from poplibr_main.p
+		-os_library_command- moved here from poplibr_main.p
 --- John Gibson, Jul 17 1989
-        Extracted from Unix versions of asmout.p
-        Added -run*_poplink-
+		Extracted from Unix versions of asmout.p
+		Added -run*_poplink-
  */
Only in v15.6301-amd64/pop/src/syscomp: os_comms.p.adm64.orig
Only in v15.6301-amd64/pop/src/syscomp: os_comms.p.orig
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/poplink_main.p v15.6301-amd64/pop/src/syscomp/poplink_main.p
--- v15.63/pop/src/syscomp/poplink_main.p	2005-01-04 09:45:04.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/poplink_main.p	2005-03-11 05:30:40.000000000 -0500
@@ -191,7 +191,7 @@
 
 	define lconstant gen_clos(lab_list, nargs, upd, pdpt, frozl);
 		lvars	f, lab_list, nargs, upd, len_lab, pdpt, frozl,
-				nfroz = listlength(frozl), len = 7+nfroz;
+				nfroz = listlength(frozl), len = 5+nfroz;
 
 		asm_outword(props,						;;; PD_PROPS
 					asm_symlabel('procedure_key'),	;;; KEY
@@ -1308,6 +1308,8 @@
 	DATA -> asmf_charout_seg;
 	out_objmod_pad(-1);
 	asm_outglab(asm_symlabel('Sys$-\^_data_seg_end'));
+        ;;; Make sure the label does not jump to the next file
+        asm_outword(0, 1);
 	endfile(fileout_4, true);
 
 
Only in v15.6301-amd64/pop/src/syscomp: poplink_main.p.orig
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/symdefs.p v15.6301-amd64/pop/src/syscomp/symdefs.p
--- v15.63/pop/src/syscomp/symdefs.p	1997-03-05 10:35:08.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/symdefs.p	2009-12-24 15:32:15.000000000 -0500
@@ -131,6 +131,26 @@
 	word	K_END_V[0];			;;; dummy field to get word length of key
   };
 
+#_IF DEF FRAME_LEN_16BIT
+deftype
+  stk_off_t = short;
+constant macro PD_FRAME_SPARE = [ short PD_FRAME_SPARE_S ; ] ;
+#_ELSE
+#_IF DEF FRAME_LEN_32BIT
+deftype
+  stk_off_t = int;
+constant macro PD_FRAME_SPARE = [ 
+        short PD_FRAME_SPARE_S ;
+        int PD_FRAME_SPARE_I;
+] ;
+#_ELSE 
+deftype
+  stk_off_t = byte;
+constant macro PD_FRAME_SPARE = [] ;
+#_ENDIF
+#_ENDIF
+
+
 
 constant macro (
 	;;; start of all procedures
@@ -150,7 +170,8 @@
 		byte	PD_FLAGS2,			;;; second flags byte
 				PD_SPARE;			;;; currently unused
 		short	PD_REGMASK;			;;; mask for register locals
-		byte	PD_FRAME_LEN,		;;; total size of stack frame in words
+                PD_FRAME_SPARE
+		stk_off_t	PD_FRAME_LEN,		;;; total size of stack frame in words
 				PD_GC_OFFSET_LEN,	;;; word index from frame pointer to lowest addr lword for gc scan
 				PD_GC_SCAN_LEN,		;;; no of stack frame words for gc scan
 				PD_NUM_STK_VARS,	;;; no of stack allocated locals
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/sysdefs.p v15.6301-amd64/pop/src/syscomp/sysdefs.p
--- v15.63/pop/src/syscomp/sysdefs.p	2005-01-06 11:43:11.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/sysdefs.p	2009-12-26 11:41:20.000000000 -0500
@@ -29,17 +29,24 @@
 	;;; Values for machine and C data types are defined in mcdata.p,
 	;;; and can be overidden here if necessary
 
+        WORD_BITS       = 64,
+
+;;;        POPINT_BITS     = 62,
+        POPINT_BITS     = 61,
+
 	SHORT_ALIGN_BITS = 8,		;;; alignment in bits for short access
 	INT_ALIGN_BITS	 = 8,		;;; alignment in bits for int access
 	DOUBLE_ALIGN_BITS = 8,		;;; alignment in bits for double access
 
 	STRUCT_SHORT_ALIGN_BITS	= 16,	;;; bit alignment for short
 	STRUCT_INT_ALIGN_BITS   = 32,	;;; bit alignment for int
-	STRUCT_DOUBLE_ALIGN_BITS = 32,	;;; bit alignment for double
+	STRUCT_DOUBLE_ALIGN_BITS = 64,	;;; bit alignment for double
 
 	CODE_POINTER_TYPE = "byte",	;;; type of pointer to machine code
 	BIT_POINTER_TYPE = "byte",	;;; type of pointer for bitfield access
 
+        ;;; FRAME_LEN_32BIT = true,
+
 
 ;;; === OPERATING SYSTEM (UNIX BSD) ==================================
 
@@ -53,6 +60,9 @@
 
 	SHARED_LIBRARIES = true,
 
+        BSD_MMAP                = true,                 ;;; has -mmap- and -mprotect- facilities
+        BSD_MPROTECT    = true,
+
 	VPAGE_OFFS = 4096,		;;; word address offset of a virtual page
 
 	;;; LOWEST_ADDRESS:
@@ -61,7 +71,7 @@
 	;;; UNIX_USRSTACK:
 	;;; 	????
 
-	UNIX_USRSTACK  = 16:FC000000,
+	UNIX_USRSTACK  = 16:FC0000000,
 
 	;;; Procedures to get and set the memory break and return the REAL end of
 	;;; memory. (We always need the real end to ensure that the end of the
@@ -104,7 +114,7 @@
 
 	;;; Include M-code listing in assembly language files
 
-	M_DEBUG = false,
+	M_DEBUG = true,
 
 );
 
@@ -113,6 +123,8 @@
 
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Mar 13 2005
+		Patch for AMD64 poplog provided by Waldek Hebisch
 --- Aaron Sloman, Jan  6 2005
 	Changed to set		 C_FLOAT_RESULT_SINGLE = false,
 	to fix bug in invocations of external programs returning single
Only in v15.6301-amd64/pop/src/syscomp: sysdefs.p.orig
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/sysdefs_linux_elf.p v15.6301-amd64/pop/src/syscomp/sysdefs_linux_elf.p
--- v15.63/pop/src/syscomp/sysdefs_linux_elf.p	2005-01-06 11:43:11.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/sysdefs_linux_elf.p	2005-03-11 05:30:40.000000000 -0500
@@ -29,13 +29,17 @@
 	;;; Values for machine and C data types are defined in mcdata.p,
 	;;; and can be overidden here if necessary
 
+        WORD_BITS       = 64,
+
+        POPINT_BITS     = 62,
+
 	SHORT_ALIGN_BITS = 8,		;;; alignment in bits for short access
 	INT_ALIGN_BITS	 = 8,		;;; alignment in bits for int access
 	DOUBLE_ALIGN_BITS = 8,		;;; alignment in bits for double access
 
 	STRUCT_SHORT_ALIGN_BITS	= 16,	;;; bit alignment for short
 	STRUCT_INT_ALIGN_BITS   = 32,	;;; bit alignment for int
-	STRUCT_DOUBLE_ALIGN_BITS = 32,	;;; bit alignment for double
+	STRUCT_DOUBLE_ALIGN_BITS = 64,	;;; bit alignment for double
 
 	CODE_POINTER_TYPE = "byte",	;;; type of pointer to machine code
 	BIT_POINTER_TYPE = "byte",	;;; type of pointer for bitfield access
@@ -53,6 +57,9 @@
 
 	SHARED_LIBRARIES = true,
 
+        BSD_MMAP                = true,                 ;;; has -mmap- and -mprotect- facilities
+        BSD_MPROTECT    = true,
+
 	VPAGE_OFFS = 4096,		;;; word address offset of a virtual page
 
 	;;; LOWEST_ADDRESS:
@@ -61,7 +68,7 @@
 	;;; UNIX_USRSTACK:
 	;;; 	????
 
-	UNIX_USRSTACK  = 16:FC000000,
+	UNIX_USRSTACK  = 16:FC0000000,
 
 	;;; Procedures to get and set the memory break and return the REAL end of
 	;;; memory. (We always need the real end to ensure that the end of the
@@ -104,7 +111,7 @@
 
 	;;; Include M-code listing in assembly language files
 
-	M_DEBUG = false,
+	M_DEBUG = true,
 
 );
 
Only in v15.6301-amd64/pop/src/syscomp: sysdefs_linux_elf.p.orig
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/syspop.p v15.6301-amd64/pop/src/syscomp/syspop.p
--- v15.63/pop/src/syscomp/syspop.p	1997-03-08 12:35:35.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/syspop.p	2005-03-11 05:30:40.000000000 -0500
@@ -1353,7 +1353,7 @@
 			match_struct_init(init, type_spec, base_p, false, false, false)
 											+ offset -> offset
 		else
-			struct_err(init, 1, 'illegal initialisation for field')
+			struct_err(type_spec, init, 2, 'illegal initialisation for field')
 		endif
 	enddefine;	/* match_spec_init */
 
@@ -1457,7 +1457,7 @@
 			false
 		endif;
 		unless () then
-			struct_err(init, 1, 'illegal initialisation for field')
+			struct_err(type_code, init, 2, 'illegal initialisation for field')
 		endunless;
 
 		;;; result is a pair -- see :GEN free_struct
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscomp/w_util.p v15.6301-amd64/pop/src/syscomp/w_util.p
--- v15.63/pop/src/syscomp/w_util.p	1995-11-10 09:15:14.000000000 -0500
+++ v15.6301-amd64/pop/src/syscomp/w_util.p	2009-12-30 14:27:21.000000000 -0500
@@ -179,7 +179,7 @@
 	*/
 define word_dict_cell(word);
 	lvars string = fast_word_string(word), len = datalength(string), word;
-
+#_IF false
 	if len fi_> 2 then
 		;;; use first, middle and last chars and length
 		f_subs(1,string) fi_+ len
@@ -195,7 +195,29 @@
 	else
 		0
 	endif -> len;
-	(len fi_&& 16:3FF) fi_+ 1
+#_ELSE
+    lvars res = len, i = 1;
+    while len fi_> 3 do
+        (f_subs(i, string) fi_+ (f_subs(i fi_+ 1, string) fi_<< 8) 
+           fi_+ (f_subs(i fi_+ 2, string) fi_<< 16))
+           + (f_subs(i fi_+ 3, string) << 24) + res -> res;
+        len fi_- 4 -> len;
+        i fi_+ 4 -> i;
+    endwhile;
+    if len == 3 then
+        (f_subs(i, string) fi_+ (f_subs(i fi_+ 1, string) fi_<< 8) 
+           fi_+ (f_subs(i fi_+ 2, string) fi_<< 16))
+             + res -> res;
+    elseif len == 2 then
+        (f_subs(i, string) fi_+ (f_subs(i fi_+ 1, string) fi_<< 8))
+             +  res -> res;
+    elseif len == 1 then
+        f_subs(i, string) + res -> res;
+    endif;
+    ;;; Mix bits
+    ((res && 16:FFFE0000) >> 17) ||/& res -> res;
+#_ENDIF
+    (res && 16:3FF) fi_+ 1
 enddefine;
 
 define path_index_cell(pathstr, word);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syscreate.p v15.6301-amd64/pop/src/syscreate.p
--- v15.63/pop/src/syscreate.p	1997-03-08 08:26:31.000000000 -0500
+++ v15.6301-amd64/pop/src/syscreate.p	2005-03-11 05:30:39.000000000 -0500
@@ -51,7 +51,7 @@
 	endif -> ;
 	_statb!ST_MODE -> _mode;
 
-	if _neg(_extern[NI] access(_file, _2)) then
+	if ((_extern[NI] access(_file, _2)) _gr _2147483647) then
 		Set_enotdir(file);
 		if _ERRNO == _:ENOENT then
 			0		;;; doesn't exist
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sysdate.p v15.6301-amd64/pop/src/sysdate.p
--- v15.63/pop/src/sysdate.p	1998-03-26 09:42:57.000000000 -0500
+++ v15.6301-amd64/pop/src/sysdate.p	2005-03-11 05:30:39.000000000 -0500
@@ -21,6 +21,9 @@
 #_IF DEFV SUNOS < 5.0 or DEF OSF1 or DEFV ULTRIX >= 4.0
 lconstant macro USE_TM_ZONE = true;
 #_ELSEIF DEF SYSTEM_V or DEF HPUX or DEF LINUX or DEF AIX
+#_IF DEF LINUX
+lconstant macro USE_TM_ZONE = true;
+#_ENDIF
 lconstant macro TZNAME = [tzname:data];		;;; Timezone name for System V systems
 #_ELSEIF DEF IRIX
 lconstant macro TZNAME = [_tzname:data];	;;; Timezone name for System V systems
@@ -53,6 +56,8 @@
 	lvars seconds, local_time, _tzlen, _tzone, _date_addr, _timep;
 	lstackmem time_t _secs, byte _buf[128];
 
+;;;        _extern printf('before Check_integral') -> _;
+;;;        _extern fflush(_0) -> _;
 	Check_integral(seconds);
 #_IF EXCEEDS_POPINT_SIGNED(time_t)
 	Pint_->_sint
@@ -61,11 +66,18 @@
 #_ENDIF (seconds, _MOST_POSITIVE_SIGNED(time_t)) -> _secs!(time_t);
 
 	if local_time then
+;;;        _extern printf('before localtime') -> _;
+;;;        _extern fflush(_0) -> _;
 		_extern localtime(_secs)
 	else
+;;;        _extern printf('before gmtime') -> _;
+;;;        _extern fflush(_0) -> _;
 		_extern gmtime(_secs)
 	endif -> _timep;
 
+;;;        _extern printf('before asctime') -> _;
+;;;        _extern fflush(_0) -> _;
+
 	_extern asctime(_timep) -> _date_addr;
 
 	;;; get timezone name
@@ -75,13 +87,21 @@
 #_ELSEIF DEF TZNAME
 	;;; get it from tzname -- 1st word is timezone, 2nd is dst timezone
 	if _zero(_timep!TM_ISDST) then
+;;;     _extern printf('before TZNAME!((b))[_0]') -> _;
+;;;        _extern fflush(_0) -> _;
+
 		_extern TZNAME!((b))[_0]
 	else
+;;;     _extern printf('before TZNAME!((b))[_1]') -> _;
+;;;        _extern fflush(_0) -> _;
 		_extern TZNAME!((b))[_1]
 	endif -> _tzone;
 
 #_ELSEIF DEF BERKELEY
 	lstackmem struct TIMEVAL _tvp;
+;;;     _extern printf('before gettimeofday') -> _;
+;;;        _extern fflush(_0) -> _;
+
 	_extern gettimeofday(_tvp, _buf) -> ;
 	_extern timezone(_buf!TZN_MINUTESWEST, _timep!TM_ISDST) -> _tzone;
 
@@ -89,6 +109,9 @@
 #_ENDIF
 
 	;;; move timezone name into date -- 24 chars ignores the newline etc
+;;;     _extern printf('before _bmove') -> _;
+;;;        _extern fflush(_0) -> _;
+
 	_bmove(@@(b)[_24], _date_addr, _buf) -> ;
 	;;; insert timezone string
 	##(b){_locc(_tzone, @@(b)[_128], _0)} -> _tzlen;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sysfork.p v15.6301-amd64/pop/src/sysfork.p
--- v15.63/pop/src/sysfork.p	1995-08-26 11:08:59.000000000 -0400
+++ v15.6301-amd64/pop/src/sysfork.p	2005-03-11 05:30:39.000000000 -0500
@@ -82,7 +82,7 @@
 
 	_extern pop_fork() -> _child_id;
 
-	if _neg(_child_id) then
+	if (_child_id) _gr 2147483647 then
 		Syserr_mishap(0, 'UNABLE TO FORK')
 	elseif _zero(_child_id) then
 		;;; the child
@@ -188,7 +188,7 @@
 	##(csword){_call_stack_hi, _vf_tmp}
 				-> _vf_stk@(struct VFRET)[_vf_n]!CSTKLEN;
 
-	if _neg(_do_vfork()) then
+	if (_do_vfork()) _gr _2147483647 then
 		unless _vfork_child then _extern _pop_sigmask(_0) -> endunless;
 		Syserr_mishap(0, 'UNABLE TO VFORK')
 	endif;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sysio.p v15.6301-amd64/pop/src/sysio.p
--- v15.63/pop/src/sysio.p	1995-11-29 08:06:31.000000000 -0500
+++ v15.6301-amd64/pop/src/sysio.p	2005-03-11 05:30:39.000000000 -0500
@@ -40,7 +40,7 @@
 		_extern[NI] pop_close(_stdfd) ->
 	else
 		;;; try to keep old standard file open under another descriptor
-		if _nonneg(_extern[NI] fcntl(_stdfd, _F_DUPFD, _3) ->> _tmp) then
+		if (_extern[NI] fcntl(_stdfd, _F_DUPFD, _3) ->> _tmp) _lteq _2147483647 then
 			_tmp -> std_dev!D_FILE_DESC;
 			_extern[NI] fcntl(_tmp, _F_SETFD, _1) -> ; 	;;; set close-on-exec
 			_extern[NI] pop_close(_stdfd) ->
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sysisdirectory.p v15.6301-amd64/pop/src/sysisdirectory.p
--- v15.63/pop/src/sysisdirectory.p	1997-03-08 09:15:01.000000000 -0500
+++ v15.6301-amd64/pop/src/sysisdirectory.p	2005-03-11 05:30:39.000000000 -0500
@@ -20,7 +20,7 @@
 	_CLAWBACK_SAVE;
 	sysfileok(path, false) -> path;
 	if datalength(path) == 0 then '.' -> path endif;
-	_nonneg(_extern[NI] stat(Encode_sys(path,_nbuf), _statb))
+	_extern[NI] stat(Encode_sys(path,_nbuf), _statb) _lteq _2147483647
 		and _statb!ST_MODE _bimask _STM_IFMT == _STM_IFDIR;
 	Clawback(0) ->
 enddefine;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syslink.p v15.6301-amd64/pop/src/syslink.p
--- v15.63/pop/src/syslink.p	1997-03-08 09:33:33.000000000 -0500
+++ v15.6301-amd64/pop/src/syslink.p	2005-03-11 05:30:39.000000000 -0500
@@ -26,7 +26,7 @@
 define sysunlink() with_nargs 1;
 	lvars file = Symlink_target();
 	lstackmem stackbuff _nbuf;
-	while _neg(_extern unlink(Encode_sys(file,_nbuf))) do
+	while (_extern unlink(Encode_sys(file,_nbuf))) _gr _2147483647 do
 		if _ERRNO == _:EINTR then _CHECKINTERRUPT; nextloop endif;
 		Set_enotdir(file);
 		returnif(_ERRNO == _:ENOENT) (false);
@@ -59,7 +59,7 @@
 	Symlink_target(file1, _flags _bitst _2:01) -> file1;
 	Symlink_target(file2, _flags _bitst _2:10) -> file2;
 
-	while _neg(try_link(file1, Encode_sys(file2,_nbuf2))) do
+	while (try_link(file1, Encode_sys(file2,_nbuf2))) _gr _2147483647 do
 		if _ERRNO == _:EINTR then _CHECKINTERRUPT; nextloop endif;
 		Set_enotdir(file1);
 		Set_enotdir(file2);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sysopen.p v15.6301-amd64/pop/src/sysopen.p
--- v15.63/pop/src/sysopen.p	1997-03-10 09:06:52.000000000 -0500
+++ v15.6301-amd64/pop/src/sysopen.p	2005-03-11 05:30:39.000000000 -0500
@@ -51,7 +51,7 @@
 	if _ERRNO == _:ENOENT then
 		;;; check whether it's because the directory doesn't exist
 		Fname_path(file, true) -> file;
-		if _neg(_extern[NI] access(Encode_sys(file,_nbuf), _0)) then
+		if (_extern[NI] access(Encode_sys(file,_nbuf), _0)) _gr _2147483647 then
 			_:ENOTDIR -> _ERRNO
 		endif
 	endif
@@ -75,7 +75,8 @@
 		procedure;
 			lstackmem stackbuff _obuf;
 			lvars _len = _extern readlink((), _obuf, _:SIZEOF(stackbuff));
-			_nonneg(_len) and Consstring_bptr(_obuf, _len, CSB_LSTACKMEM)
+			/* _nonneg(_len) */ (_len _lteq _2147483647) 
+                        and Consstring_bptr(_obuf, _len, CSB_LSTACKMEM)
 		endprocedure( Encode_sys(target,_nbuf) ) -> linkval;
 		;;; if not a symbolic link return target
 		returnunless(linkval);
@@ -94,7 +95,7 @@
 
 define Sys_open(file, accmode, arg3, open_p, _iscreate);
 	lvars	file, accmode, arg3, procedure open_p, fullname,
-			_iscreate, _errc, _fd;
+			_iscreate, _errc, _fd, ress;
 
 	if isinteger(arg3) then
 		;;; optional character arg specifying error action
@@ -119,8 +120,16 @@
 		endif
 	endif;
 
-	returnif(_nonneg( open_p(file, fullname, accmode, 0) ->> _fd ))
-		( Sys_cons_device(file, fullname, accmode, arg3, _pint(_fd), false) );
+        if(( open_p(file, fullname, accmode, 0) ->> _fd ) _lteq _2147483647) 
+        then
+;;;          _extern printf('doing Sys_cons_device\n') -> _ ;
+;;;          _extern fflush(_0) -> _ ;
+	  Sys_cons_device(file, fullname, accmode, arg3, _pint(_fd), false)
+           -> ress;
+;;;          _extern printf('after Sys_cons_device\n') -> _ ;
+;;;          _extern fflush(_0) -> _ ;
+          return (ress);
+        endif;
 
 	;;; can't open/create file
 	Set_enotdir(fullname);
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syspipe.p v15.6301-amd64/pop/src/syspipe.p
--- v15.63/pop/src/syspipe.p	1994-06-01 12:15:39.000000000 -0400
+++ v15.6301-amd64/pop/src/syspipe.p	2005-03-11 05:30:39.000000000 -0500
@@ -26,7 +26,7 @@
 		quitif((Sys_fd_open_check(_pint(_res), false, _retry) ->> _retry)
 						fi_< 0)
 	endrepeat;
-	if _neg(_res) then Syserr_mishap(0, 'CAN\'T CREATE PIPE') endif;
+	if (_res) _gr _2147483647 then Syserr_mishap(0, 'CAN\'T CREATE PIPE') endif;
 
 	_fdp!(int)[_0] -> _fd_in;
 	_fdp!(int)[_1] -> _fd_out;
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/syspop.ph v15.6301-amd64/pop/src/syspop.ph
--- v15.63/pop/src/syspop.ph	1998-04-30 10:34:06.000000000 -0400
+++ v15.6301-amd64/pop/src/syspop.ph	2005-03-11 05:30:39.000000000 -0500
@@ -109,7 +109,7 @@
 	s_stackbuff	= short[460];
 
 struct TIMEVAL
-  { -int TIM_SEC, TIM_USEC; };
+  { -long TIM_SEC, TIM_USEC; };
 
 struct CODING_FUNCS
   { (code)	CDFN_ENCODE,	;;; UNICODE -> something
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/sysutil.p v15.6301-amd64/pop/src/sysutil.p
--- v15.63/pop/src/sysutil.p	2000-01-06 11:13:22.000000000 -0500
+++ v15.6301-amd64/pop/src/sysutil.p	2005-03-11 05:30:39.000000000 -0500
@@ -39,8 +39,8 @@
 			_n _sub _1 -> _n
 		enduntil;
 		;;; do the call and loop if EINTR
-		unless _neg(_call_sys((), _nargs, _routine) ->> _res)
-		and _ERRNO == _:EINTR then
+		unless (_call_sys((), _nargs, _routine) ->> _res) 
+                  _gr _2147483647 and _ERRNO == _:EINTR then
 			_useras(@@(w)[_nargs]);			;;; remove args
 			return
 		endunless
@@ -53,7 +53,8 @@
 define Set_mem_prot(_base, _lim, _prot);
 	lvars _base, _lim, _prot;
 #_IF DEF BSD_MPROTECT
-	_nonneg(_extern mprotect(_base@(w->b), ##(b){_lim, _base | w}, _prot))
+	(_extern mprotect(_base@(w->b), ##(b){_lim, _base | w}, _prot))
+           _lteq _2147483647
 #_ELSE
 	"undef"
 #_ENDIF
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/termcap.p v15.6301-amd64/pop/src/termcap.p
--- v15.63/pop/src/termcap.p	2004-03-15 05:05:14.000000000 -0500
+++ v15.6301-amd64/pop/src/termcap.p	2009-12-24 15:31:23.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Sussex 2004. All rights reserved. ----------
+/* --- Copyright University of Sussex 1998. All rights reserved. ----------
  > File:            C.unix/src/termcap.p
  > Purpose:         Simple interface to C termcap library
  > Author:          Rob Duncan, Apr 11 1989 (see revisions)
@@ -11,9 +11,7 @@
 	*/
 #_TERMIN_IF DEF NCR
 
-/* Too many problems with termcap on linux systems. */
-#_TERMIN_IF DEF LINUX
-
+#_TERMIN_IF false
 
 #_INCLUDE 'declare.ph'
 #_INCLUDE 'io.ph'
@@ -58,7 +56,8 @@
 	;;; problem
 	['-B static -lcurses -B dynamic']
 #_ELSE
-	['-ltermcap']
+;;;	['-ltermcap']
+        ['-lncurses']
 #_ENDIF
 	lconstant exload_dummy;		;;; anything will do
 endexload;
@@ -524,7 +523,7 @@
 	lvars id, _res;
 	Check_termcap_id(id) -> id;
 	returnunless(termcap_entry_name)(false);
-	if _nonneg(_extern tgetnum(id@V_BYTES) ->> _res) then
+	if (_extern tgetnum(id@V_BYTES) ->> _res) _lteq _2147483647 then
 		_pint(_res);
 	else
 		false;
@@ -599,8 +598,6 @@
 
 
 /* --- Revision History ---------------------------------------------------
---- Aaron Sloman, 15 Mar 2004
-		Ignore termcap if DEF LINUX. See comp.lang.pop discussions
 --- John Gibson, Mar 26 1998
 		Set -lcurses for AIX
 --- Robert Duncan, Aug 14 1997
